<?
 require_once($_path["include"]."data.php");

 class graphics extends BasePlugin
 {
  function output()
  {
   global $_path;

   $output="";

   if(!$this->config)
    return $output;

   require_once($this->plugin->path["root"]."graph.php");

   $g=new Graph();
   $d=Data::cache("graphics_pluginConfigs");

   if($this->config["border"])
    $g->border("drawing", $this->config["border"]);

   $g->autoAddLineLabels=false;

   $axis=Array("X");
   for($c=1;$c<=$d->moduleObject->dataSets;$c++)
   {
    if($this->config["axis_".$c]!="None")
     if(!in_array($this->config["axis_".$c], $axis))
      $axis[]=$this->config["axis_".$c];
   }

   foreach($axis as $axe)
   {
    if($axe=="X")
     $g->axis($axe, strtolower($this->config["style"]), ($this->config["lock_min_".$axe]?$this->config["min_".$axe]:false), ($this->config["lock_max_".$axe]?$this->config["max_".$axe]:false));
    else
     $g->axis($axe, "X", ($this->config["lock_min_".$axe]?$this->config["min_".$axe]:false), ($this->config["lock_max_".$axe]?$this->config["max_".$axe]:false));

    $g->color($axe, $this->config["color_".$axe]);

    if($this->config["title_".$axe])
    {
     if(strtolower($this->config["style"])=="horizontal")
     {
      if($axe=="X")
       $g->text($axe, $this->config["title_".$axe], 1); //right
      else
       $g->text($axe, $this->config["title_".$axe], 0); //top
     }
     else
     {
      if($axe=="X")
       $g->text($axe, $this->config["title_".$axe], 0); //top
      else
       $g->text($axe, $this->config["title_".$axe], 1); //right
     }
    }

    if($this->config["grid_".$axe])
    {
     $g->grid($axe);
     $g->color("grid_".$axe, $this->config["grid_color_".$axe]);
    }

    if($this->config["labels_".$axe])
    {
     $g->labels($axe);
     $g->color($axe, $this->config["color_".$axe], false, $this->config["labels_color_".$axe]);

     if($this->config["labels_display_".$axe]=="auto")
      $g->display($axe, "normal", $this->config["labels_append_".$axe]);
     else if($this->config["labels_display_".$axe]=="size")
      $g->display($axe, $this->config["labels_display_".$axe], $this->config["labels_append_".$axe]);
     else if($this->config["labels_display_".$axe]=="date")
      $g->display($axe, $this->config["labels_display_".$axe], false);
    }

    if($this->config["indicators_".$axe])
     $g->indicator($axe);

    if($this->config["margin_".$axe])
     $g->margin($axe, $this->config["margin_".$axe]/100);

    if($this->config["interval_".$axe])
    {
     $tmp=Data::cache($this->plugin->name."_pluginConfigs");
     $this->config["interval_".$axe]=floatval(str_replace($tmp->format[$tmp->dataformat]["decimalseparator"], $tmp->format["sql"]["decimalseparator"], str_replace($tmp->format[$tmp->dataformat]["thousandsseparator"], $tmp->format["sql"]["thousandsseparator"], $this->config["interval_".$axe])));
     unset($tmp);

     $g->interval($axe, $this->config["interval_".$axe]);
    }
   }

   $x=0;
   for($c=1;$c<=$d->moduleObject->dataSets;$c++)
   {
    if($this->config["axis_".$c]!="None")
    {
     if($this->config["set_type_".$c]=="static")
     {
      if($this->config["type_".$c]=="line")
      {
       $g->line("line_".$x, $this->config["axis_".$c], explode(" ", $this->config["set_".$c]));
       $g->color("line_".$x, $this->config["color_".$c]);
       $g->width("line_".$x, $this->config["line_width_".$c]);

       if($this->config["show_values_".$c])
        foreach(explode(" ", $this->config["set_".$c]) as $k => $v)
         $g->tooltip("line_".$x, str_replace(",", ": ", $v), $k);

       $x++;
      }
      else if($this->config["type_".$c]=="point")
      {
       foreach(explode(" ", $this->config["set_".$c]) as $k => $v)
       {
        $g->line("line_".$x."_".$k, $this->config["axis_".$c], $v);
        $g->color("line_".$x."_".$k, $this->config["color_".$c]);
        $g->width("line_".$x."_".$k, $this->config["line_width_".$c]);

        if($this->config["show_values_".$c])
         $g->tooltip("line_".$x."_".$k, str_replace(",", ": ", $v));
       }

       $x++;
      }
      else if($this->config["type_".$c]=="bar")
      {
       foreach(explode(" ", $this->config["set_".$c]) as $v)
       {
        $g->bar("bar_".$x, $this->config["axis_".$c], $v, $this->config["bar_size_".$c]);
        $g->color("bar_".$x, $this->config["color_".$c]);
        $g->width("bar_".$x, $this->config["bar_width_".$c]);

        if($this->config["show_values_".$c])
         $g->tooltip("bar_".$x, str_replace(",", ": ", $v));

        $x++;
       }
      }
     }
     else if($this->config["set_type_".$c]=="data")
     {
      $base=$this->config["base_field_".$c];
      $vals=$this->config["values_field_".$c];

      if(!isset($ds)||$ds->getValue("nr")!=$this->config["data_set_".$c])
      {
       $ds=Data::cache("dataset", "view", "item");
       $ds->setShowFields("data");
       $ds->setValue("showFields", Array($this->config["base_field_".$c], $this->config["values_field_".$c]));
       $ds->setValue("nr", $this->config["data_set_".$c]);

       if(!$ds->get()||!$ds->next())
       {
        $this->e->add($ds->e);
        return false;
       }

       $rds=$ds->v["data"];

       if($rds->field[$base]["type"]=="date"||$rds->field[$base]["type"]=="time"||$rds->field[$base]["type"]=="datetime")
        $g->dateFormat("X", $rds->field[$base]["format"][$rds->dataformat][$rds->field[$base]["type"]."format"]);
      }
       
      if($this->config["type_".$c]=="line")
      {
       $tmp=Array();
       while($rds->next())
        $tmp[]=$rds->v[$base].",".$rds->sqlValue($vals, $rds->vc-1);

       $g->line("line_".$x, $this->config["axis_".$c], $tmp);
       $g->color("line_".$x, $this->config["color_".$c]);
       $g->width("line_".$x, $this->config["line_width_".$c]);

       if($this->config["show_values_".$c])
        while($rds->next())
         $g->tooltip("line_".$x, $rds->v[$base].": ".$rds->v[$vals], $rds->vc-1);

       $x++;
      }
      else if($this->config["type_".$c]=="point")
      {
       while($rds->next())
       {
        $v=$rds->v[$base].",".$rds->sqlValue($vals, $rds->vc-1);

        $g->line("line_".$x."_".$rds->vc, $this->config["axis_".$c], $v);
        $g->color("line_".$x."_".$rds->vc, $this->config["color_".$c]);
        $g->width("line_".$x."_".$rds->vc, $this->config["line_width_".$c]);

        if($this->config["show_values_".$c])
         $g->tooltip("line_".$x."_".$rds->vc, str_replace(",", ": ", $v));
       }

       $x++;
      }
      else if($this->config["type_".$c]=="bar")
      {
       while($rds->next())
       {
        $g->bar("bar_".$x, $this->config["axis_".$c], $rds->v[$base].",".$rds->sqlValue($vals, $rds->vc-1), $this->config["bar_size_".$c]);
        $g->color("bar_".$x, $this->config["color_".$c]);
        $g->width("bar_".$x, $this->config["bar_width_".$c]);

        if($this->config["show_values_".$c])
         $g->tooltip("bar_".$x, $rds->v[$base].": ".$rds->v[$vals], $rds->vc-1);

        $x++;
       }
      }
     }
    }
   }

   foreach($axis as $axe)
    if($this->config["labels_".$axe])
     if($this->config["labels_display_".$axe]=="date")
      if($this->config["labels_dateformat_".$axe])
        $g->dateFormat($axe, $this->config["labels_dateformat_".$axe]);
    
   $output=$g->style();
   $output.=$g->render($this->config["width"], $this->config["height"]);

   return $output;
  }
 }

?>
